/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class RolleExtendedDAO extends AbstractRolleDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: AllNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByAll" ,  mandant  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByAll(): Miss");
        }

        cache.put(key, super.findByAll( mandant  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByAll(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByAll( mandant  );
}
/**
* Name: BenutzerEinsatzortNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Rolle o, BenutzerEinsatzort b WHERE o MEMBER OF b.rolles AND b=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByBenutzerEinsatzort( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort benutzerEinsatzort) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByBenutzerEinsatzort" ,  benutzerEinsatzort  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByBenutzerEinsatzort(): Miss");
        }

        cache.put(key, super.findByBenutzerEinsatzort( benutzerEinsatzort  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByBenutzerEinsatzort(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByBenutzerEinsatzort( benutzerEinsatzort  );
}
/**
* Name: BenutzerNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Rolle o, Benutzer b WHERE o MEMBER OF b.rolles AND b=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByBenutzer( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzer) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByBenutzer" ,  benutzer  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByBenutzer(): Miss");
        }

        cache.put(key, super.findByBenutzer( benutzer  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByBenutzer(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByBenutzer( benutzer  );
}
/**
* Name: GebietRolleNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Rolle o WHERE (SELECT COUNT(g) FROM Gebiet g WHERE g.einsehenRolle = o)>0 OR (SELECT COUNT(g) FROM Gebiet g WHERE g.bearbeitenRolle = o)>0 AND o.mandant = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByGebietRolle( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByGebietRolle" ,  mandant  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebietRolle(): Miss");
        }

        cache.put(key, super.findByGebietRolle( mandant  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebietRolle(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByGebietRolle( mandant  );
}
/**
* Name: NameNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1 AND o.name=?2<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByName( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String name) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByName" ,  mandant ,  name  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByName(): Miss");
        }

        cache.put(key, super.findByName( mandant ,  name  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByName(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByName( mandant ,  name  );
}
/**
* Name: WahlRolleNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Rolle o WHERE (SELECT COUNT(w) FROM Wahl w WHERE w.einsehenRolle = o)>0 OR (SELECT COUNT(w) FROM Wahltermin w WHERE w.einsehenRolle = o)>0 AND o.mandant=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Rolle> findByWahlRolle( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByWahlRolle" ,  mandant  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlRolle(): Miss");
        }

        cache.put(key, super.findByWahlRolle( mandant  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlRolle(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Rolle>) cache.lookup(key));
    }

    return super.findByWahlRolle( mandant  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
